'
' LMM PASM implementations of fundamental multi-threading lock operations
'
' int _thread_init_lock_pool (void *pool, int size, int lock);
'    initialize a pool of locks
' on entry:
'    r2 = lock to use for this pool (0 .. 7)
'    r3 = size of this pool
'    r4 = pointer to pool (size + 5) bytes of Hub RAM
' on exit:
'    r0 = 0 on success, -1 on failure
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Export _thread_init_lock_pool

 long ' align long

C__thread_init_lock_pool
 mov RI, r4             ' write size ...
 mov BC, r3
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... to the pool
#endif
 add r4, #4
 mov RI, r4             ' write lock ...
 mov BC, r2
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 wrbyte BC, RI          ' ... to the pool
#endif
:thr_pool_fill
 add r4, #1             ' initialize all pool locks ...
 sub r3, #1
 cmp r3, #0 wz
 jmp #BR_Z
 long @:thr_pool_done
 mov RI, r4 
 mov BC, #0
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 wrbyte BC, RI
#endif   
 jmp #JMPA
 long @:thr_pool_fill   ' ... to zero (unallocated)
:thr_pool_done
 mov r0, #0
 jmp #RETN
'
