'
' LMM PASM implementations of fundamental multi-threading operations
'
' void * _thread_join(void * block, int *result);
'    wait for a thread to terminate
' on entry:
'    r3 = thread id to join
'    r2 = address to store result (r0 of joined thread)
' on exit
'    r0 = thread id if joined
'    r0 = 0 if error (e.g. attempt to join own thread)
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Export _thread_join

 long ' align long

C__thread_join
 lockset lock wc
 jmp #BR_B
 long @C__thread_join
 cmp r3, TP wz          ' request to join current thread?
 jmp #BR_Z              ' yes - return ...
 long @:thr_join_error  ' ... error
 mov RI, r3             ' no - has thread ...
 add RI, #33*4+1
#ifdef LARGE
 jmp #RBYT
#elseifdef SMALL
 jmp #RBYT
#else
 rdbyte BC, RI          
#endif
 test BC, #%10000000 wz ' ... been terminated?
 jmp #BRNZ              ' yes return ...
 long @:thr_join_error  ' ... error
 test BC, #%01000000 wz ' no - has thread completed?
 jmp #BR_Z              ' no - keep ...
 long @:thr_join_wait   ' ... waiting 
 mov RI, r3             ' yes - load ...
 add RI, #9*4
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... thread r0
#endif
 mov RI, r2             ' save it ...
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... as the result
#endif
 mov r0, r3 wz          ' return thread block (and Z clr)
 lockclr lock
 jmp #JMPA
 long @:thr_join_exit
:thr_join_wait 
 jmp #LMM_force         ' force a context switch immediately
 jmp #JMPA              ' when we return ...
 long @C__thread_join   ' ... try again
:thr_join_error
 mov r0, #0 wz          ' if not found or error, return zero (and Z set)
 lockclr lock
:thr_join_exit 
 jmp #RETN
'
