'
' LMM PASM implementations of fundamental multi-threading operations
'
' _unlocked_check (void *block)
'    unlocked version of _thread_check (for internal use)
' on entry:
'    r4 = thread id to check
' on exit:
'    r0 = thread id (and Z clr) if found
'    r0 = 0 (and Z set) if not found
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Export _unlocked_check

C__unlocked_check
 cmp r4, TP wz          ' are we looking for the current thread?
 jmp #BR_Z              ' yes - the thread ...
 long @:unl_check_found ' ... was found
 mov r1, TP             ' no - start searching from current thread
:unl_check_next
 mov RI, r1             ' get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... the next thread pointer
#endif
 mov r1, BC             ' is it ...
 cmp r1, TP wz          ' ... the same as the current thread?
 jmp #BR_Z              ' yes - we are back at the start of the thread ring ...
 long @:unl_check_not_found ' ... which means the thread is not executing
 cmp r1, r4 wz          ' no - is this the thread we want?
 jmp #BR_Z              ' yes - the specified thread ...
 long @:unl_check_found ' ... is still executing
 jmp #JMPA              ' no - keep ...
 long @:unl_check_next  ' ... looking
:unl_check_not_found
 mov r0, #0 wz          ' if not found, return zero (and Z set)
 jmp #JMPA
 long @:unl_check_exit
:unl_check_found
 mov r0, r4 wz          ' if found, return thread block (and Z clr)
:unl_check_exit
 jmp #RETN
'
