'
' LMM PASM implementations of fundamental multi-threading lock operations
'
' int _thread_lockset(void *pool, int lockid);
'    set a lock, and return the previous value
' on entry:
'    r2 = lock id
'    r3 = pointer to pool (size + 1) bytes
' on exit:
'    r0 = previous value of lock (0 or 1), or -1 on error
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Import _thread_pool_setup

' Catalina Export _thread_lockset

 long ' align long

C__thread_lockset
 jmp #CALA              ' get pool lock into r1 and ...
 long @C__thread_pool_setup ' ... pool size into r4 and lock the pool
 cmp r2, #1 wz,wc       ' is the lock in the pool?
 jmp #BR_B              ' no - return ...
 long @:thr_lset_error  ' ... with error
 cmp r2, r4 wz,wc       ' is the lock in the pool?
 jmp #BR_A              ' no - return ...
 long @:thr_lset_error  ' ... with error
 mov RI, r3             ' yes - read ...
 add RI, #4
 add RI, r2
#ifdef LARGE
 jmp #RBYT
#elseifdef SMALL
 jmp #RBYT
#else
 rdbyte BC, RI          ' ... the lock byte
#endif
 test BC, #$80 wz       ' check allocation bit
 jmp #BR_Z              ' if not allocated ...
 long @:thr_lset_error  ' ... return an error
 mov r0, BC             ' save the last state ...
 and r0, #1             ' ... of the lock
 mov BC, #$81           ' set ...
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 Wrbyte BC, RI          ' ... the lock
#endif
 jmp #JMPA              ' return ...
 long @:thr_lset_done   ' ... the previous state of the lock
:thr_lset_error
 neg r0, #1             ' return -1 on error
:thr_lset_done 
 lockclr r1 wc          ' release the lock on the pool
 jmp #RETN
'
