#include "catalina_cog.h"

/*
 * Include the dynamic kernel formatted as a C array. The array was produced
 * using the following commands:
 *
 *       homespun Catalina_LMM_dynamic.spin -b -o LMM
 *       spinc LMM.binary > LMM_dynamic_array.h
 */
#include "LMM_dynamic_array.h"


/*
 * _coginit_C : start a C function in a new cog.
 *
 * On entry:
 *    func  : address of C function to run (defined as 'void func (void)')
 *    stack : address of TOP of stack to use (i.e. points just after last long)
 * On exit:
 *    cog   : cog used, or -1 on any error
 */
int _coginit_C(void func(void), unsigned long *stack) {
   int cog;
   struct {
      unsigned long REG;
      unsigned long PC;
      unsigned long SP;
   } cog_data;
 
   cog_data.REG = _registry(); // registry address
   cog_data.PC  = (unsigned long)func;  // address of C function
   cog_data.SP  = (unsigned long)stack; // top of stack
   cog = _coginit((int)&cog_data>>2, (int)LMM_dynamic_array>>2, ANY_COG);
   _waitcnt(_cnt() + (_clockfreq()/10)); // small delay for cog to initialize
   return cog;
}

