#include <catalina_graphics.h>

extern int _cgi_cog;

// Draw a box with round/square corners, according to pixel width
//
//   x,y      - box left, box bottom
//
void g_box(g_var *gv, int x, int y, int box_width, int box_height) {
   int x2, y2, pmin, pmax;

   if ((box_width > gv->PIXEL_WIDTH) 
   &&  (box_height > gv->PIXEL_WIDTH)) {

      //get pixel-half-min and pixel-half-max
      pmax = gv->PIXEL_WIDTH - (pmin = (gv->PIXEL_WIDTH >> 1));

      x += pmin; //adjust coordinates to accomodate width
      y += pmin;
      x2 = x + box_width - 1 - gv->PIXEL_WIDTH;
      y2 = y + box_height - 1 - gv->PIXEL_WIDTH;

      g_plot(gv, x, y); // plot round/square corners
      g_plot(gv, x, y2);
      g_plot(gv, x2, y);
      g_plot(gv, x2, y2);

      g_fill(gv, x, y2 + pmax, 0, (x2 - x) << 16, 0, 0, pmax); // fill gaps
      g_fill(gv, x, y, 0, (x2 - x) << 16, 0, 0, pmin);
      g_fill(gv, x - pmin, y2, 0, (x2 - x + gv->PIXEL_WIDTH) << 16, 0, 0,
             y2 - y);
   }
}
