#include "stdint.h"
#include <catalina_sd.h>
#include <dosfs.h>


#if __CATALINA_DEBUG_DOSFS

static void press_to_continue() {
   int ch;

   t_string(1, "Press any key to continue\n");
   ch = k_wait();
}
#endif

uint32_t DFS_ReadSector(uint8_t unit, uint8_t *buffer, uint32_t sector, uint32_t count)
{
   int i;

#if __CATALINA_DEBUG_DOSFS
   t_string(1, "\nDFS_ReadSector ");
   t_integer(1, sector);
   t_string(1, "\n");
   press_to_continue();
#endif

#if DOSFS_CAN_COUNT
   if (count == 1) {
      sd_sectread((char *)buffer, sector);
   }
   else {
      for (i = 0; i < count; i++) {
         sd_sectread((char *)(buffer + 512*i), sector + i);
      }
   }
#else
   sd_sectread((char *)buffer, sector);
#endif
   return 0;
}


