'
' LMM PASM implementations of affinity multi-threading operations
'
' void * _thread_affinity_change();
'    request affinity change for specified thread
' on entry:
'    r3 = thread id
'    r2 = new affinity
' on exit:
'    r0 = thread id on success (Z clr)
'    r0 = 0 (Z set) on error
'       
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Export _thread_affinity_change

 long ' align long

C__thread_affinity_change
 lockset lock wc
 jmp #BR_B
 long @C__thread_affinity_change
 and r2, #%111          ' ensure new affinity is in range 0 .. 7
 mov RI, r2             ' get request block address ...
 shl RI, #2
 add RI, reg          
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... of new cog 
#endif
 mov r4, BC             ' save in r4
 mov RI, r4             ' is there ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' 
#endif
 cmp BC, #0 wz          ' ... an affinity request outstanding for that cog?
 jmp #BRNZ              ' yes - return ...
 long @:aff_ch_error    ' ... error
 mov r1, TP             ' no - start with current thread block
:aff_ch_next
 mov RI, r1             ' get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... the next thread pointer from that block
#endif
 cmp BC, r3 wz          ' is it the thread block we are looking for?
 jmp #BR_Z              ' yes - found ...
 long @:aff_ch_found    ' .. the block pointing to the thread block to change 
 cmp BC, TP wz          ' no - last thread? (points to current thread block)
 jmp #BR_Z              ' yes - return ... 
 long @:aff_ch_error    ' ... error
 mov r1, BC             ' no - step to ...
 jmp #JMPA              ' ... this thread block ...
 long @:aff_ch_next     ' ... and keep looking
:aff_ch_found           ' now r1 points to block that points to r3
 cogid r0               ' are we trying to change the cog ...
 cmp r0, r2 wz          ' .. to be the same as the current cog id?
 jmp #BR_Z              ' yes - no need ...
 long @:aff_ch_done     ' ... to do anything!
 cmp r3, TP wz          ' are we changing affinity of the current thread?
 jmp #BRNZ              ' no - can just update ...
 long @:aff_ch_remove   ' ... the appropriate block pointers
 mov RI, TP             ' yes - get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... the next thread block pointer 
#endif
 cmp BC, TP wz          ' is only one thread executing?
 jmp #BR_Z              ' yes - cannot change affinity ...
 long @:aff_ch_error    ' ... of the last thread using this function
:aff_ch_remove
 mov RI, r3             ' get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... the next thread pointer of block being changed
#endif
 mov RI, r1             ' write it to ...
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... the next block of the previous block pointer
#endif
 mov RI, r4             ' notify new cog ...
 mov BC, r3
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... of cog change request
#endif
 cmp r3, TP wz          ' are we changing the affinity of the current thread?
 jmp #BRNZ              ' if not ...
 long @:aff_ch_done     ' ... then we are done
 jmp #LMM_force         ' otherwise force a context switch immediately
 mov r0, r3 wz          ' when we get here, return ...
 jmp #JMPA              ' ... thread id (and Z clr)
 long @:aff_ch_exit            
:aff_ch_done
 mov r0, r3 wz          ' return ...
 lockclr lock           ' ... thread id (and Z clr)
 jmp #JMPA
 long @:aff_ch_exit
:aff_ch_error
 mov r0, #0 wz          ' if error, return zero (and Z set)
 lockclr lock
:aff_ch_exit
 jmp #RETN
'
