'
' LMM PASM implementations of fundamental multi-threading operations
'
' _thread_halt : threads come here when they exit their thread function
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Import _unlocked_prev

' Catalina Export _thread_halt

 long ' align long

C__thread_halt
 lockset lock wc
 jmp #BR_B
 long @C__thread_halt
 mov r5, r0             ' save r0
 mov RI, TP             ' write r0 ...
 add RI, #9*4
 mov BC, r0
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... to our register save area
#endif
 mov RI, TP             ' set ...
 add RI, #33*4+1
#ifdef LARGE
 jmp #RBYT
#elseifdef SMALL
 jmp #RBYT
#else
 rdbyte BC, RI
#endif
 or BC, #%01000000
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 wrbyte BC, RI          ' ... thread completed bit
#endif 
 mov r2, TP             ' find thread block ...
 jmp #CALA
 long @C__unlocked_prev ' ... that points to this thread block
 jmp #BR_Z              ' if not found ...
 long @:thr_halt_done   ' ... cannot do any more
 mov r1, r0             ' now r1 points to block that points to r2
 mov RI, TP             ' get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... next thread block pointer from current block
#endif
 cmp BC, TP wz          ' is only one thread executing?
 jmp #BR_Z              ' yes - cannot ...
 long @:thr_halt_done   ' ... do any more
 mov RI, r1             ' no - write next thread block pointer ...
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... to the next pointer of the previous block
#endif
:thr_halt_done
 mov r0,r5              ' restore r0 (in case we are still executing)
:thr_halt_loop
 jmp #LMM_force         ' force a context switch immediately
 jmp #JMPA              ' if we ever get here ...
 lockset lock wc
 jmp #BR_B
 long @:thr_halt_loop   ' ... just force another context switch
 jmp #RETN              ' optimizer needs this
'
