'
' LMM PASM implementations of fundamental multi-threading lock operations
'
' int _thread_locknew(void *pool);
'    allocate a new lock from the pool
' on entry:
'    r2 = pointer to pool (size + 1) bytes
' on exit:
'    r0 = lock on success (1 .. size), -1 on failure
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Import _thread_pool_setup

' Catalina Export _thread_locknew

 long ' align long

C__thread_locknew
 mov r3,r2              ' point to pool with r3
 jmp #CALA              ' get pool lock into r1 and ...
 long @C__thread_pool_setup ' ... pool size into r4 and lock the pool
 add r3, #5             ' point to ...
 mov r0, #1             ' ... first lock
:thr_lnew_check
 cmp r0, r4 wz,wc       ' have we reached end of pool?
 jmp #BR_A              ' yes - return
 long @:thr_lnew_error  ' ... with error
 mov RI, r3             ' no - read ...
#ifdef LARGE
 jmp #RBYT
#elseifdef SMALL
 jmp #RBYT
#else
 rdbyte BC, RI          ' ... the lock byte
#endif
 test BC, #$80 wz       ' check allocation bit
 jmp #BR_Z              ' if not allocated ...
 long @:thr_lnew_found  ' ... use this lock
 add r0, #1             ' otherwise ...
 add r3, #1             ' ... keep ...
 jmp #JMPA              ' ... looking ...
 long @:thr_lnew_check  ' ... until we run out of locks
:thr_lnew_found
 mov BC, #$80           ' allocate ...
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 Wrbyte BC, RI          ' ... the lock byte (and set it to unlocked)
#endif
 jmp #JMPA              ' return with ...
 long @:thr_lnew_done   ' ... the lock number
:thr_lnew_error
 neg r0, #1             ' return -1 on error
:thr_lnew_done 
 lockclr r1 wc          ' release the lock on the pool
 jmp #RETN
'
