'
' LMM PASM implementations of fundamental multi-threading lock operations
'
' int _thread_lockret(void *pool, int lockid);
'    return a lock to the pool
' on entry:
'    r2 = lock id
'    r3 = pointer to pool (size + 1) bytes
' on exit:
'    r0 = 0 on success, -1 on failure
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Import _thread_pool_setup

' Catalina Export _thread_lockret

 long ' align long

C__thread_lockret
 jmp #CALA              ' get pool lock into r1 and ...
 long @C__thread_pool_setup ' ... pool size into r4 and lock the pool
 cmp r2, #1 wz,wc       ' is the lock in the pool?
 jmp #BR_B              ' no - return ...
 long @:thr_lret_error  ' ... with error
 cmp r2, r4 wz,wc       ' is the lock in the pool?
 jmp #BR_A              ' no - return ...
 long @:thr_lret_error  ' ... with error
 mov RI, r3             ' yes - read ...
 add RI, #4
 add RI, r2
#ifdef LARGE
 jmp #RBYT
#elseifdef SMALL
 jmp #RBYT
#else
 rdbyte BC, RI          ' ... the lock byte
#endif
 test BC, #$80 wz       ' check allocation bit
 jmp #BR_Z              ' if not allocated ...
 long @:thr_lret_error  ' ... return an error
 mov BC, #0             ' otherwise release ...
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 Wrbyte BC, RI          ' ... the lock byte (and set it to unlocked)
#endif
 mov r0, #0             ' return ...
 jmp #JMPA              ' ... zero ...
 long @:thr_lret_done   ' ... to indicate success
:thr_lret_error
 neg r0, #1             ' return -1 on error
:thr_lret_done 
 lockclr r1 wc          ' release the lock on the pool
 jmp #RETN
'
