'
' LMM PASM implementations of fundamental multi-threading operations
'
' void * _thread_start(void * PC, void * SP, int argc, char *argv[]);
'    intiate a new thread
' on entry:
'    r5 = initial PC
'    r4 = initial SP (must be at least 39 longs below this !)
'    r3 = argc
'    r2 = argv
' on exit:
'    r0 = thread id (Z clear) on success
'    r0 = 0 and Z flag set on error
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Import _unlocked_check

' Catalina Import _thread_halt

' Catalina Export _thread_start

 long ' align long

C__thread_start
 lockset lock wc
 jmp #BR_B
 long @C__thread_start
 sub r4, #34*4          ' use top 34 longs of stack as thread block
 jmp #CALA
 long @C__unlocked_check ' check if thread id is already known
 jmp #BRNZ              ' if so ...
 long @:thr_start_error ' ... return error 
 mov RI, r4             ' set up ...
 add RI, #33*4    
 cogid BC
 shl BC, #8
#ifdef LARGE
 jmp #WWRD
#elseifdef SMALL
 jmp #WWRD
#else
 wrword BC, RI          ' ... affinity with our cog id
#endif
 add RI, #2             ' set up ...
 mov BC, #100           ' ... (~10 milliseconds) ...
#ifdef LARGE
 jmp #WWRD
#elseifdef SMALL
 jmp #WWRD
#else
 wrword BC, RI          ' ... default tick count
#endif
 mov RI, r4             ' set up ...
 add RI, #11*4
 mov BC, r2
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... thread r2 (argv) 
#endif
 mov RI, r4             ' set up ...
 add RI, #12*4
 mov BC, r3
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... thread r3 (argc)
#endif
 mov RI, r4             ' set up ...
 add RI, #1*4             
 mov BC, r5
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC,RI           ' ... thread PC
#endif
 mov r1, r4
 sub R1, #4*3           ' reserve 3 longs of stack for args and return addr
 jmp LODL               ' set up ...
 long @C__thread_halt
 mov BC, RI
 mov RI, r1
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... thread return address
#endif
 mov RI, r4             ' set up ...
 add RI, #2*4
 mov BC, r1
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... thread SP
#endif
 mov RI, TP             ' get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... next block pointer of current thread block
#endif
 mov RI, r4             ' set it as ...
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... next block pointer of new thread block
#endif
 mov RI, TP             ' set ...
 mov BC, r4
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... next block pointer of current block to new block
#endif
 mov r0, r4 wz          ' if ok, return thread block (and Z clr)
 lockclr lock
 jmp #JMPA
 long @:thr_start_exit
:thr_start_error
 mov r0, #0 wz          ' if error, return zero (and Z set) 
 lockclr lock
:thr_start_exit
 jmp #RETN
'
