'
' LMM PASM implementations of fundamental multi-threading operations
'
' void * _thread_stop(void * block);
'    terminate a thread (which may be current thread!)
' on entry:
'    r2 = thread id to terminate
' on exit
'    r0 = thread id if terminated (& Z clr)
'    r0 = 0 (& Z set) if error (e.g. attempt to terminate last thread)
'
' Catalina Code

DAT ' code segment

' Catalina Import _thread_id

' Catalina Import _unlocked_prev

' Catalina Export _thread_stop

 long ' align long

C__thread_stop
 lockset lock wc
 jmp #BR_B
 long @C__thread_stop
 jmp #CALA
 long @C__unlocked_prev ' find thread block that points to this thread block
 jmp #BR_Z              ' if not found ...
 long @:thr_stop_error  ' ... return error
 mov r1, r0             ' now r1 points to block that points to r2
 cmp r2, TP wz          ' are we terminating the current thread?
 jmp #BRNZ              ' no - can just update ...
 long @:thr_stop_remove ' ... the appropriate block pointers
 mov RI, TP             ' yes - get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... the next thread block pointer 
#endif
 cmp BC, TP wz          ' is only one thread executing?
 jmp #BR_Z              ' yes - cannot terminate ...
 long @:error           ' ... last thread using this function
:thr_stop_remove
 mov RI, r2             ' ... get ...
#ifdef LARGE
 jmp #RLNG
#elseifdef SMALL
 jmp #RLNG
#else
 rdlong BC, RI          ' ... the next thread pointer of block being terminated
#endif
 mov RI, r1             ' write it to ...
#ifdef LARGE
 jmp #WLNG
#elseifdef SMALL
 jmp #WLNG
#else
 wrlong BC, RI          ' ... the block pointing to the block being terminated
#endif
 mov RI, r2             ' set ...
 add RI, #33*4+1
#ifdef LARGE
 jmp #RBYT
#elseifdef SMALL
 jmp #RBYT
#else
 rdbyte BC, RI
#endif
 or BC, #%10000000
#ifdef LARGE
 jmp #WBYT
#elseifdef SMALL
 jmp #WBYT
#else
 wrbyte BC, RI          ' ... thread terminated bit
#endif 
 cmp r2, TP wz          ' are we terminating current thread?
 jmp #BRNZ              ' if not ...
 long @:the_stop_done   ' ... then we are done
 jmp #LMM_force         ' otherwise force a context switch immediately
 mov r0, #0 wz          ' if we ever get here ...
 jmp #JMPA              ' ... return an error
 long @:thr_stop_exit
:thr_stop_done
 mov r0, r2 wz          ' if ok, return thread block (and Z clr)
 lockclr lock
 jmp #JMPA
 long @:thr_stop_exit
:thr_stop_error
 mov r0, #0 wz          ' if not found, return zero (and Z set)
 lockclr lock
:thr_stop_exit
 jmp #RETN
'
